SystemOrganization addCategory: #'CS528-UT3Base'!

Object subclass: #UT3Board
	instanceVariableNames: 'boardMatrix boardGlobalMatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Board commentStamp: '<historical>' prior: 0!
An UT3Board is a board.

Instance Variables
!

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 19:08'!
checkWinningWithCol: aColNum matrix: subMatrix

	|  |
	^self checkWinningWithSet: ((subMatrix atCol: aColNum) asSet).! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 19:09'!
checkWinningWithDiagonal: aRowNum matrix: subMatrix

	| ret1 ret2  |
	ret1 := self checkWinningWithSet: ((subMatrix diagonal) asSet).
	ret2 := self checkWinningWithSet: ( Set newFrom: { (subMatrix at: 1 at: 3). (subMatrix at: 2 at: 2). (subMatrix at: 3 at: 1)}  ).! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 19:08'!
checkWinningWithRow: aRowNum matrix: subMatrix

	|  |
	^self checkWinningWithSet: ((subMatrix atRow: aRowNum) asSet).! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 18:50'!
checkWinningWithSet: aSet

	|  |
	(aSet size = 3)
	ifTrue:["judge"
		((aSet sizeFor: 1) = 3)
		ifTrue:[ ^1 ]
		ifFalse:[
			((aSet sizeFor: 2) = 3)
				ifTrue:[ ^2 ]
				ifFalse:[ ^false ].
			]
		]! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 18:59'!
checkWinningWithSubMatrix: aMatrix

	|  |
	self checkWinningWithRow: 1.
	self checkWinningWithRow: 2.
	self checkWinningWithRow: 3.
	self checkWinningWithCol: 1.
	self checkWinningWithCol: 2.
	self checkWinningWithCol: 3.! !

!UT3Board methodsFor: 'initialize-release' stamp: 'Oliver 7/1/2013 18:54'!
initialize 

	|  |
	boardMatrix := Matrix new: 9.
	boardMatrix atAllPut: 0.
	boardGlobalMatrix := Matrix new: 3.
	boardGlobalMatrix atAllPut: 0.! !

!UT3Board methodsFor: 'as yet unclassified' stamp: 'Oliver 7/1/2013 19:09'!
player: aPlayer moveX: aMove1 moveY: aMove2

	| tempR tempC subMatrix |
	( (0) == boardMatrix at: aMove1 at: aMove2 )
	ifTrue:[ boardMatrix at: aMove1 at: aMove2 put: aPlayer ]
	ifFalse:[ self error: 'Player could only be 1 or 2 and one can only play in an empty slot!!'   ].
	
	tempR := (aMove1 - (aMove1 % 3)) * 3 + 1.
	tempC := (aMove2 - (aMove2 % 3)) * 3 + 1.
	subMatrix := boardMatrix atRows: tempR to: (tempR+2) columns: tempC to: (tempC+2).
	^self checkWinningWithSubMatrix: subMatrix.
	! !

Object subclass: #UT3System
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3System commentStamp: '<historical>' prior: 0!
An UT3System is the class encapsulating an entire Ultimate TicTacToe game.

It contains an interface to make moves for each player, and holds an instance of UT3Board that represents the game board state, and is stateful in the sense that it records each player's move.

You can use the provided API to get the which player's turn it is, etc. Invalid moves will throw MoveError.

Instance Variables
!
